"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var ej2_ng_diagrams_1 = require("@syncfusion/ej2-ng-diagrams");
/**
 * Default FlowShape sample
 */
var FlowDiagramComponent = (function () {
    function FlowDiagramComponent() {
        this.nodes = [
            {
                id: 'HTML1', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 288, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
            {
                id: 'HTML2', borderColor: 'black', borderWidth: 1, offsetX: 150, offsetY: 250, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
            {
                id: 'HTML3', borderColor: 'black', borderWidth: 1, offsetX: 300, offsetY: 150, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
            {
                id: 'HTML4', borderColor: 'black', borderWidth: 1, offsetX: 450, offsetY: 250, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
            {
                id: 'HTML5', borderColor: 'black', borderWidth: 1, offsetX: 400, offsetY: 400, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
            {
                id: 'HTML6', borderColor: 'black', borderWidth: 1, offsetX: 200, offsetY: 400, height: 100, width: 100,
                annotations: [{ content: 'Button' }],
                shape: {
                    type: 'HTML',
                    content: '<button type="button" style="width:100px"> Button</button>'
                }
            },
        ];
        this.snapSettings = {
            constraints: ej2_ng_diagrams_1.SnapConstraints.None
        };
    }
    FlowDiagramComponent.prototype.nodeDefaults = function (obj) {
        obj.style = { fill: '#37909A', strokeColor: '#024249' };
        obj.annotations[0].margin = { left: 10, right: 10 };
        obj.annotations[0].style = { color: 'white', fill: 'none', strokeColor: 'none' };
        return obj;
    };
    FlowDiagramComponent.prototype.connDefaults = function (obj) {
        obj.targetDecorator.style = { fill: '#024249', strokeColor: '#024249' };
        obj.style = { strokeColor: '#024249', strokeWidth: 2 };
    };
    FlowDiagramComponent.prototype.ngOnInit = function () {
        document.getElementById('appearance').onclick = this.documentClick.bind(this);
    };
    FlowDiagramComponent.prototype.onChangeAspectRatio = function (args) {
        for (var i = 0; i < this.diagram.nodes.length; i++) {
            var node = this.diagram.nodes[i];
            var isShadowEnabled = node.constraints & ej2_ng_diagrams_1.NodeConstraints.Shadow;
            if (args.checked) {
                node.constraints =
                    ej2_ng_diagrams_1.NodeConstraints.AspectRatio | ej2_ng_diagrams_1.NodeConstraints.Default;
            }
            else {
                node.constraints =
                    ej2_ng_diagrams_1.NodeConstraints.Default & ~ej2_ng_diagrams_1.NodeConstraints.AspectRatio;
            }
            if (isShadowEnabled) {
                node.constraints |= ej2_ng_diagrams_1.NodeConstraints.Shadow;
            }
            this.diagram.dataBind();
        }
    };
    FlowDiagramComponent.prototype.onChangeLock = function (args) {
        for (var i = 0; i < this.diagram.nodes.length; i++) {
            var node = this.diagram.nodes[i];
            var isShadowEnabled = node.constraints & ej2_ng_diagrams_1.NodeConstraints.Shadow;
            if (args.checked) {
                node.constraints =
                    ej2_ng_diagrams_1.NodeConstraints.PointerEvents | ej2_ng_diagrams_1.NodeConstraints.Select;
            }
            else {
                node.constraints = ej2_ng_diagrams_1.NodeConstraints.Default;
            }
            if (isShadowEnabled) {
                node.constraints |= ej2_ng_diagrams_1.NodeConstraints.Shadow;
            }
            this.diagram.dataBind();
        }
    };
    FlowDiagramComponent.prototype.documentClick = function (args) {
        var node;
        var target = args.target;
        var selectedElement = document.getElementsByClassName('e-selected-style');
        if (selectedElement.length) {
            selectedElement[0].classList.remove('e-selected-style');
        }
        if (target.className === 'image-pattern-style') {
            for (var i = 0; i < this.diagram.nodes.length; i++) {
                node = this.diagram.nodes[i];
                switch (target.id) {
                    case 'preview0':
                        this.applyStyle(node, 0, undefined, ~ej2_ng_diagrams_1.NodeConstraints.Shadow, undefined);
                        break;
                    case 'preview1':
                        this.applyStyle(node, 2, undefined, ~ej2_ng_diagrams_1.NodeConstraints.Shadow, undefined);
                        break;
                    case 'preview2':
                        this.applyStyle(node, 2, '5,5', ~ej2_ng_diagrams_1.NodeConstraints.Shadow, undefined);
                        break;
                    case 'preview3':
                        this.applyStyle(node, 2, '5,5', ~ej2_ng_diagrams_1.NodeConstraints.Shadow, 'Radial');
                        break;
                    case 'preview4':
                        this.applyStyle(node, 2, '5,5', ej2_ng_diagrams_1.NodeConstraints.Shadow, undefined);
                        break;
                }
                target.classList.add('e-selected-style');
            }
        }
    };
    FlowDiagramComponent.prototype.applyStyle = function (node, width, dashArray, con, type) {
        node.style.fill = '#37909A';
        node.style.strokeWidth = width;
        node.style.strokeColor = '#024249';
        node.style.strokeDashArray = dashArray;
        node.backgroundColor = '#024249';
        node.borderWidth = width;
        node.borderColor = 'red';
        node.constraints &= con;
        if (type === undefined) {
            node.style.gradient.type = 'None';
        }
        else {
            var gradient = void 0;
            gradient = {
                cx: 50, cy: 50, fx: 50, fy: 50,
                stops: [
                    { color: '#00555b', offset: 0 },
                    { color: '#37909A', offset: 90 }
                ],
                type: 'Radial'
            };
            node.style.gradient = gradient;
        }
        if (con & ej2_ng_diagrams_1.NodeConstraints.Shadow) {
            node.shadow = { angle: 45, distance: 15, opacity: 0.3, color: 'grey' };
            node.constraints |= con;
        }
        this.diagram.dataBind();
    };
    return FlowDiagramComponent;
}());
__decorate([
    core_1.ViewChild('diagram'),
    __metadata("design:type", ej2_ng_diagrams_1.DiagramComponent)
], FlowDiagramComponent.prototype, "diagram", void 0);
FlowDiagramComponent = __decorate([
    core_1.Component({
        selector: 'main-section',
        templateUrl: 'app/diagram/diagram.component.html',
        encapsulation: core_1.ViewEncapsulation.None
    })
], FlowDiagramComponent);
exports.FlowDiagramComponent = FlowDiagramComponent;
//# sourceMappingURL=diagram.component.js.map