import { NgModule }      from '@angular/core';
import { DiagramModule, HierarchicalTreeService, DataBindingService, SymbolPaletteModule } from '@syncfusion/ej2-ng-diagrams';
import { CheckBoxModule } from '@syncfusion/ej2-ng-buttons';
import { BrowserModule } from '@angular/platform-browser';

import { AppComponent }  from './app.component';
import { FlowDiagramComponent  } from  './diagram/diagram.component';

@NgModule({
  imports:      [ BrowserModule, DiagramModule, SymbolPaletteModule, CheckBoxModule],
  declarations: [ FlowDiagramComponent , AppComponent],
  bootstrap:    [ AppComponent],
  providers: [ HierarchicalTreeService, DataBindingService ]
})
export class AppModule { }
